 #property copyright "www.fxproadvisor.com"
#property link      "www.fxproadvisor.com"

extern double Lots = 0.1;
extern int LotsMax = 10;
extern bool IncreasingLot = TRUE;
extern int LotsPercent = 5;
extern int DropDown = 95;
extern int SinFastPeriod = 55;
extern int SinSlowPeriod = 89;
extern bool UseFilter = TRUE;
extern bool InfoComment = TRUE;
double gd_116;
double gd_124;
string gs_132 = "";
 
 
int deinit() {
   Comment("");
   return (0);
}

double GetSizeLot() {
   double ld_ret_0;
   if (IncreasingLot == FALSE) ld_ret_0 = Lots;
   if (IncreasingLot == TRUE) {
      ld_ret_0 = MathCeil(AccountFreeMargin() / 10000.0 * LotsPercent) / 10.0;
      if (ld_ret_0 < 0.1) ld_ret_0 = 0.1;
      if (ld_ret_0 > LotsMax) ld_ret_0 = LotsMax;
   }
   return (ld_ret_0);
}

int Signal() {
   int li_0 = 1;
   gd_116 = (iClose("EURJPY", PERIOD_H4, li_0) - iClose("EURJPY", PERIOD_H4, li_0 + SinFastPeriod)) / Point / MathSqrt(MathPow((iClose("EURJPY", PERIOD_H4, li_0) - iClose("EURJPY", PERIOD_H4, li_0 +
      SinFastPeriod)) / Point, 2) + MathPow(li_0 + SinFastPeriod, 2));
   gd_124 = (iClose("EURJPY", PERIOD_H4, li_0) - iClose("EURJPY", PERIOD_H4, li_0 + SinSlowPeriod)) / Point / MathSqrt(MathPow((iClose("EURJPY", PERIOD_H4, li_0) - iClose("EURJPY", PERIOD_H4, li_0 +
      SinSlowPeriod)) / Point, 2) + MathPow(li_0 + SinSlowPeriod, 2));
   if (UseFilter && gd_116 > 0.0 || gd_124 > 0.0) {
      gs_132 = "Trade allowed.";
      return (1);
   }
   if (!UseFilter) return (1);
   gs_132 = "Trade signals are being filtered now. Trade is not allowed. Yen is strong. Closing positions is highly recommended.";
   return (0);
}

int isMagNum(string a_symbol_0, int a_magic_8) {
   int l_ord_total_12 = OrdersTotal();
   for (int l_pos_16 = 0; l_pos_16 < l_ord_total_12; l_pos_16++) {
      OrderSelect(l_pos_16, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_8 && OrderSymbol() == a_symbol_0) return (1);
   }
   return (0);
}

int isMagNumTotal(int a_magic_0) {
   int l_count_4 = 0;
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURUSD") l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURJPY") l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "USDJPY") l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "AUDUSD") l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "NZDUSD") l_count_4++;
   }
   if (l_count_4 == 5) return (1);
   return (0);
}

void OrderOpen(int a_magic_0) {
   double ld_4;
   if (TimeCurrent() <= 1535688000) {
      ld_4 = GetSizeLot();
      if (isMagNum("EURUSD", a_magic_0) == 0) OrderSend("EURUSD", OP_SELL, NormalizeDouble(ld_4, 1), MarketInfo("EURUSD", MODE_BID), 10, 0, 0, "5", a_magic_0, 0);
      if (isMagNum("EURJPY", a_magic_0) == 0) OrderSend("EURJPY", OP_BUY, NormalizeDouble(ld_4, 1), MarketInfo("EURJPY", MODE_ASK), 10, 0, 0, "5", a_magic_0, 0);
      if (isMagNum("USDJPY", a_magic_0) == 0) OrderSend("USDJPY", OP_BUY, NormalizeDouble(ld_4, 1), MarketInfo("USDJPY", MODE_ASK), 10, 0, 0, "5", a_magic_0, 0);
      if (isMagNum("AUDUSD", a_magic_0) == 0) OrderSend("AUDUSD", OP_BUY, NormalizeDouble(0.8 * ld_4, 1), MarketInfo("AUDUSD", MODE_ASK), 10, 0, 0, "5", a_magic_0, 0);
      if (isMagNum("NZDUSD", a_magic_0) == 0) OrderSend("NZDUSD", OP_BUY, NormalizeDouble(0.8 * ld_4, 1), MarketInfo("NZDUSD", MODE_ASK), 10, 0, 0, "5", a_magic_0, 0);
      Comment("Trade open");
      return;
   }
}

void TakeProfit(int a_magic_0) {
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = l_ord_total_4 - 1; l_pos_8 >= 0; l_pos_8--) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_0 && OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10);
      if (OrderMagicNumber() == a_magic_0 && OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10);
   }
}

void LOSS() {
   int l_ord_total_0 = OrdersTotal();
   for (int l_pos_4 = l_ord_total_0 - 1; l_pos_4 >= 0; l_pos_4--) {
      OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == 901 && OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10);
      if (OrderMagicNumber() == 901 && OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10);
      if (OrderMagicNumber() == 902 && OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10);
      if (OrderMagicNumber() == 902 && OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10);
      if (OrderMagicNumber() == 903 && OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10);
      if (OrderMagicNumber() == 903 && OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10);
      Sleep(1000);
   }
   Alert("DROPDOWN LEVEL REACHED! IMMEDIATELY TURN OFF THE ADVISOR! Now sleeping for 3 days...");
   Sleep(259200000);
}

int checkopen1() {
   double l_iclose_0 = iClose("EURUSD", PERIOD_H1, 1);
   double l_iclose_8 = iClose("EURJPY", PERIOD_H1, 1);
   double l_iclose_16 = iClose("USDJPY", PERIOD_H1, 1);
   double l_iclose_24 = iClose("AUDUSD", PERIOD_H1, 1);
   double l_iclose_32 = iClose("NZDUSD", PERIOD_H1, 1);
   double l_iclose_40 = iClose("EURUSD", PERIOD_H1, 2);
   double l_iclose_48 = iClose("EURJPY", PERIOD_H1, 2);
   double l_iclose_56 = iClose("USDJPY", PERIOD_H1, 2);
   double l_iclose_64 = iClose("AUDUSD", PERIOD_H1, 2);
   double l_iclose_72 = iClose("NZDUSD", PERIOD_H1, 2);
   double ld_80 = 100000.0 * (l_iclose_0 - l_iclose_40) + 1000.0 * (l_iclose_48 - l_iclose_8) + 1000.0 * (l_iclose_56 - l_iclose_16) + 100000.0 * (0.8 * l_iclose_64 - 0.8 * l_iclose_24) + 100000.0 * (0.8 * l_iclose_72 - 0.8 * l_iclose_32);
   if (ld_80 > 300.0) return (1);
   return (0);
}

int checkopen2() {
   double l_ord_open_price_0;
   double l_ord_open_price_8;
   double l_ord_open_price_16;
   double l_ord_open_price_24;
   double l_ord_open_price_32;
   double l_iclose_40 = iClose("EURUSD", PERIOD_H1, 1);
   double l_iclose_48 = iClose("EURJPY", PERIOD_H1, 1);
   double l_iclose_56 = iClose("USDJPY", PERIOD_H1, 1);
   double l_iclose_64 = iClose("AUDUSD", PERIOD_H1, 1);
   double l_iclose_72 = iClose("NZDUSD", PERIOD_H1, 1);
   int l_ord_total_80 = OrdersTotal();
   for (int l_pos_84 = 0; l_pos_84 < l_ord_total_80; l_pos_84++) {
      OrderSelect(l_pos_84, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == 901 && OrderSymbol() == "EURUSD") l_ord_open_price_0 = OrderOpenPrice();
      if (OrderMagicNumber() == 901 && OrderSymbol() == "EURJPY") l_ord_open_price_8 = OrderOpenPrice();
      if (OrderMagicNumber() == 901 && OrderSymbol() == "USDJPY") l_ord_open_price_16 = OrderOpenPrice();
      if (OrderMagicNumber() == 901 && OrderSymbol() == "AUDUSD") l_ord_open_price_24 = OrderOpenPrice();
      if (OrderMagicNumber() == 901 && OrderSymbol() == "NZDUSD") l_ord_open_price_32 = OrderOpenPrice();
   }
   double ld_88 = 100000.0 * (l_iclose_40 - l_ord_open_price_0) + 1000.0 * (l_ord_open_price_8 - l_iclose_48) + 1000.0 * (l_ord_open_price_16 - l_iclose_56) + 100000.0 * (0.8 * l_ord_open_price_24 - 0.8 * l_iclose_64) + 100000.0 * (0.8 * l_ord_open_price_32 - 0.8 * l_iclose_72);
   if (ld_88 > 700.0) return (1);
   return (0);
}

int checkopen3() {
   double l_ord_open_price_0;
   double l_ord_open_price_8;
   double l_ord_open_price_16;
   double l_ord_open_price_24;
   double l_ord_open_price_32;
   double l_iclose_40 = iClose("EURUSD", PERIOD_H1, 1);
   double l_iclose_48 = iClose("EURJPY", PERIOD_H1, 1);
   double l_iclose_56 = iClose("USDJPY", PERIOD_H1, 1);
   double l_iclose_64 = iClose("AUDUSD", PERIOD_H1, 1);
   double l_iclose_72 = iClose("NZDUSD", PERIOD_H1, 1);
   int l_ord_total_80 = OrdersTotal();
   for (int l_pos_84 = 0; l_pos_84 < l_ord_total_80; l_pos_84++) {
      OrderSelect(l_pos_84, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == 902 && OrderSymbol() == "EURUSD") l_ord_open_price_0 = OrderOpenPrice();
      if (OrderMagicNumber() == 902 && OrderSymbol() == "EURJPY") l_ord_open_price_8 = OrderOpenPrice();
      if (OrderMagicNumber() == 902 && OrderSymbol() == "USDJPY") l_ord_open_price_16 = OrderOpenPrice();
      if (OrderMagicNumber() == 902 && OrderSymbol() == "AUDUSD") l_ord_open_price_24 = OrderOpenPrice();
      if (OrderMagicNumber() == 902 && OrderSymbol() == "NZDUSD") l_ord_open_price_32 = OrderOpenPrice();
   }
   double ld_88 = 100000.0 * (l_iclose_40 - l_ord_open_price_0) + 1000.0 * (l_ord_open_price_8 - l_iclose_48) + 1000.0 * (l_ord_open_price_16 - l_iclose_56) + 100000.0 * (0.8 * l_ord_open_price_24 - 0.8 * l_iclose_64) + 100000.0 * (0.8 * l_ord_open_price_32 - 0.8 * l_iclose_72);
   if (ld_88 > 1500.0) return (1);
   return (0);
}

int checkclose(int a_magic_0) {
   double l_ord_open_price_4;
   double l_ord_open_price_12;
   double l_ord_open_price_20;
   double l_ord_open_price_28;
   double l_ord_open_price_36;
   double l_iclose_44 = iClose("EURUSD", PERIOD_H1, 1);
   double l_iclose_52 = iClose("EURJPY", PERIOD_H1, 1);
   double l_iclose_60 = iClose("USDJPY", PERIOD_H1, 1);
   double l_iclose_68 = iClose("AUDUSD", PERIOD_H1, 1);
   double l_iclose_76 = iClose("NZDUSD", PERIOD_H1, 1);
   int l_ord_total_84 = OrdersTotal();
   for (int l_pos_88 = 0; l_pos_88 < l_ord_total_84; l_pos_88++) {
      OrderSelect(l_pos_88, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURUSD") l_ord_open_price_4 = OrderOpenPrice();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURJPY") l_ord_open_price_12 = OrderOpenPrice();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "USDJPY") l_ord_open_price_20 = OrderOpenPrice();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "AUDUSD") l_ord_open_price_28 = OrderOpenPrice();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "NZDUSD") l_ord_open_price_36 = OrderOpenPrice();
   }
   double ld_92 = 100000.0 * (l_iclose_44 - l_ord_open_price_4) + 1000.0 * (l_ord_open_price_12 - l_iclose_52) + 1000.0 * (l_ord_open_price_20 - l_iclose_60) + 100000.0 * (0.8 * l_ord_open_price_28 - 0.8 * l_iclose_68) + 100000.0 * (0.8 * l_ord_open_price_36 - 0.8 * l_iclose_76);
   if (a_magic_0 == 903 && ld_92 < -1800.0) return (1);
   if (a_magic_0 == 902 && ld_92 < -900.0) return (1);
   if (a_magic_0 == 901 && ld_92 < -600.0) return (1);
   return (0);
}

int TradeTime() {
   if (TimeToStr(TimeCurrent(), TIME_MINUTES) >= "00:01" && TimeToStr(TimeCurrent(), TIME_MINUTES) <= "23:59") return (1);
   return (0);
}

double OrdersEquity(int a_magic_0) {
   bool li_ret_4 = FALSE;
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURUSD") li_ret_4 = li_ret_4 + OrderProfit();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURJPY") li_ret_4 = li_ret_4 + OrderProfit();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "USDJPY") li_ret_4 = li_ret_4 + OrderProfit();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "AUDUSD") li_ret_4 = li_ret_4 + OrderProfit();
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "NZDUSD") li_ret_4 = li_ret_4 + OrderProfit();
   }
   return (li_ret_4);
}

double StopLoss() {
   double ld_0 = AccountBalance();
   if (isMagNumTotal(901) == 1 && isMagNumTotal(902) == 0 && isMagNumTotal(903) == 0 && OrdersEquity(901) < 0.0 && MathAbs(OrdersEquity(901)) / ld_0 > DropDown / 100.0) return (1);
   if (isMagNumTotal(901) == 1 && isMagNumTotal(902) == 1 && isMagNumTotal(903) == 0 && OrdersEquity(901) < 0.0 && (MathAbs(OrdersEquity(901)) + MathAbs(OrdersEquity(902))) / ld_0 > DropDown / 100.0) return (2);
   if (isMagNumTotal(901) == 1 && isMagNumTotal(902) == 1 && isMagNumTotal(903) == 1 && OrdersEquity(901) < 0.0 && (MathAbs(OrdersEquity(901)) + MathAbs(OrdersEquity(902)) +
      MathAbs(OrdersEquity(903))) / ld_0 > DropDown / 100.0) return (3);
   return (0);
}

int TimeCheck(int a_magic_0) {
   int l_count_4 = 0;
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURUSD" && OrderOpenTime() < iTime("EURUSD", PERIOD_H1, 1)) l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "EURJPY" && OrderOpenTime() < iTime("EURJPY", PERIOD_H1, 1)) l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "USDJPY" && OrderOpenTime() < iTime("USDJPY", PERIOD_H1, 1)) l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "AUDUSD" && OrderOpenTime() < iTime("AUDUSD", PERIOD_H1, 1)) l_count_4++;
      if (OrderMagicNumber() == a_magic_0 && OrderSymbol() == "NZDUSD" && OrderOpenTime() < iTime("NZDUSD", PERIOD_H1, 1)) l_count_4++;
   }
   if (l_count_4 == 5) return (1);
   return (0);
}

bool devtime() {
   if (TimeCurrent() > 1535688000) return (TRUE);
   return (FALSE);
}

int start() {
    
   if (devtime()) {
      Alert("Thank you and good luck!");
      Alert("(igor@fxproadvisor.com) and report this message!");
      Alert("a full version, please contact me via email");
      Alert("only works for one month. If you purchased");
      Alert("It is PayPal fraud protection version, which");
      Alert("Thank you for using this Advisor!");
   }
   if (!devtime()) {
      
      if (isMagNumTotal(901) == 0) Comment("PA 5 : waiting for market patterns to open position...");
      if (Signal() && TradeTime() == 1 && isMagNumTotal(901) == 0 && checkopen1() == 1) OrderOpen(901);
      if (Signal() && TradeTime() == 1 && isMagNumTotal(901) == 1 && TimeCheck(901) == 1 && isMagNumTotal(902) == 0 && checkopen2() == 1) OrderOpen(902);
      if (Signal() && TradeTime() == 1 && isMagNumTotal(901) == 1 && isMagNumTotal(902) == 1 && TimeCheck(902) == 1 && isMagNumTotal(903) == 0 && checkopen3() == 1) OrderOpen(903);
      if (TradeTime() == 1 && checkclose(901) == 1 && isMagNumTotal(901) == 1) TakeProfit(901);
      if (TradeTime() == 1 && checkclose(902) == 1 && isMagNumTotal(902) == 1) TakeProfit(902);
      if (TradeTime() == 1 && checkclose(903) == 1 && isMagNumTotal(903) == 1) TakeProfit(903);
      if (StopLoss() == 1.0 || StopLoss() == 2.0 || StopLoss() == 3.0) LOSS();
      if (InfoComment) Comment(gs_132);
   }
   return (0);
}